﻿using System;
using System.Collections.Generic;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.GanttView;
using Telerik.Windows.Controls.Scheduling;
using Telerik.Windows.Core;

namespace ShowIterationSeparator
{
    public class CustomTimelineBehavior : DefaultGanttTimeLineVisualizationBehavior
    {
        public IDateRange VisibleRange { get; set; }

        protected override IEnumerable<IEventInfo> GetEventInfos(TimeLineVisualizationState state, HierarchicalItem hierarchicalItem)
        {
            foreach (var eventInfo in base.GetEventInfos(state, hierarchicalItem))
            {
                yield return eventInfo;
            }

            var task = hierarchicalItem.SourceItem as ColoredTask;
            if (task != null && task.ShowIterationSeparator)
            {
                var roundedRange = state.Rounder.Round(new DateRange(this.VisibleRange.Start, this.VisibleRange.End));
                var separatorRange = new Range<long>(roundedRange.Start.Ticks, roundedRange.End.Ticks);

                yield return new SeparatorEventInfo(separatorRange, hierarchicalItem.Index);
            }
        }
    }
}
